OpenTTD Source: NewGRFParametersWindow Struct Reference

OpenTTD Source 15.0-beta1

Public Member Functions | Static Public Member Functions | Data Fields | Static Public Attributes
NewGRFParametersWindow Struct Reference

Window for setting the parameters of a NewGRF. More...

Inheritance diagram for NewGRFParametersWindow:

## Public Member Functions
| NewGRFParametersWindow (WindowDesc &desc, bool is_baseset, GRFConfig *c, bool editable)
bool | HasParameterInfo (uint nr) const
| Test if GRF Parameter Info exists for a given parameter index.
GRFParameterInfo & | GetParameterInfo (uint nr) const
| Get GRF Parameter Info exists for a given parameter index.
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | SetStringParameters (WidgetID widget) const override
| Initialize string parameters for a widget.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | OnPaint () override
| The window must be repainted.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnQueryTextFinished (std::optional< std::string > str) override
| The query window opened from this window has closed.
void | OnDropdownSelect (WidgetID widget, int index) override
| A dropdown option associated to this window has been selected.
void | OnDropdownClose (Point, WidgetID widget, int, bool) override
| A dropdown window associated to this window has been closed.
void | OnResize () override
| Called after the window got resized.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
template<typename T , std::enable_if_t< std::is_base_of< StrongTypedefBase, T >::value, int > = 0>
void | FinishInitNested (T number)
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnMouseDrag (Point pt, WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, WidgetID widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnEditboxChanged (WidgetID widget)
| The text in an editbox has been edited.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Static Public Member Functions
static GRFParameterInfo & | GetDummyParameterInfo (uint nr)
| Get a dummy parameter-info object with default information.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.

## Data Fields
GRFConfig * | grf_config
| Set the parameters of this GRFConfig.
int32_t | clicked_button
| The row in which a button was clicked or INT_MAX when none is selected.
bool | clicked_increase
| True if the increase button was clicked, false for the decrease button.
bool | clicked_dropdown
| Whether the dropdown is open.
bool | closing_dropdown
| True, if the dropdown list is currently closing.
int32_t | clicked_row
| The selected parameter, or INT_MAX when none is selected.
int | line_height
| Height of a row in the matrix widget.
Scrollbar * | vscroll
bool | action14present
| True if action14 information is present.
bool | editable
| Allow editing parameters.
TimeoutTimer< TimerWindow > | unclick_timeout
| When reset, unclick the button after a small timeout.
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
int | scale
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8_t | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root
| Root of the nested tree.
WidgetLookup | widget_lookup
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget
| ID of current mouse capture widget (e.g. dragged scrollbar). -1 if no widget has mouse capture.
Window * | parent
| Parent window.
WindowList::iterator | z_position

## Static Public Attributes
static GRFParameterInfo | dummy_parameter_info
| Dummy info in case a newgrf didn't provide info about some parameter.

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize
| Set if window has been resized.

## Detailed Description

Window for setting the parameters of a NewGRF.

Definition at line 146 of file newgrf_gui.cpp.

## Constructor & Destructor Documentation

## ◆ NewGRFParametersWindow()

NewGRFParametersWindow::NewGRFParametersWindow | ( | WindowDesc & | desc,
|  | bool | is_baseset,
|  | GRFConfig * | c,
|  | bool | editable
| ) |  |
| inline

Definition at line 159 of file newgrf_gui.cpp.

## Member Function Documentation

## ◆ DrawWidget()

void NewGRFParametersWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 265 of file newgrf_gui.cpp.

References _current_text_dir, clicked_row, DrawArrowButtons(), DrawBoolButton(), DrawDropDownButton(), DrawString(), DrawStringMultiLine(), WidgetDimensions::framerect, FS_NORMAL, GetCharacterHeight(), Scrollbar::GetCount(), GetGRFStringFromGRFText(), GetParameterInfo(), Scrollbar::GetPosition(), GRFConfig::GetValue(), Window::GetWidget(), HasParameterInfo(), Rect::Indent(), Scrollbar::IsVisible(), line_height, PTYPE_BOOL, PTYPE_UINT_ENUM, WidgetDimensions::scaled, SetDParam(), SetDParamStr(), SETTING_BUTTON_HEIGHT, SETTING_BUTTON_WIDTH, Rect::Shrink(), TD_RTL, GRFParameterInfo::type, WID_NP_BACKGROUND, and WID_NP_DESCRIPTION.

## ◆ GetDummyParameterInfo()

static GRFParameterInfo & NewGRFParametersWindow::GetDummyParameterInfo | ( | uint | nr | ) |
| inlinestatic

Get a dummy parameter-info object with default information.

Parameters

  nr | The param number that should be changed.

Returns
  GRFParameterInfo with dummy information about the given parameter.

Definition at line 186 of file newgrf_gui.cpp.

References dummy_parameter_info, Window::GetWidget(), and GRFParameterInfo::param_nr.

Referenced by GetParameterInfo().

## ◆ GetParameterInfo()

GRFParameterInfo & NewGRFParametersWindow::GetParameterInfo | ( | uint | nr | ) | const
| inline

Get GRF Parameter Info exists for a given parameter index.

If the parameter info does not exist, a dummy parameter-info is returned instead.

Parameters

  nr | The param number that should be got.

Returns
  Reference to the GRFParameterInfo.

Definition at line 208 of file newgrf_gui.cpp.

References GetDummyParameterInfo(), Window::GetWidget(), HasParameterInfo(), and GRFConfig::param_info.

Referenced by DrawWidget(), OnClick(), OnDropdownSelect(), and OnQueryTextFinished().

## ◆ HasParameterInfo()

bool NewGRFParametersWindow::HasParameterInfo | ( | uint | nr | ) | const
| inline

Test if GRF Parameter Info exists for a given parameter index.

Parameters

  nr | The param number that should be tested.

Returns
  True iff the parameter info exists.

Definition at line 197 of file newgrf_gui.cpp.

References Window::GetWidget(), and GRFConfig::param_info.

Referenced by DrawWidget(), and GetParameterInfo().

## ◆ OnClick()

void NewGRFParametersWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 334 of file newgrf_gui.cpp.

References _current_text_dir, Window::Close(), Window::CloseChildWindows(), CS_NUMERAL, Scrollbar::GetCount(), GetGRFStringFromGRFText(), GetParameterInfo(), Scrollbar::GetScrolledRowFromWidget(), GRFConfig::GetValue(), Window::GetWidget(), grf_config, Window::InvalidateData(), IsInsideMM(), GRFConfig::num_valid_params, GRFConfig::param, PTYPE_BOOL, PTYPE_UINT_ENUM, TimeoutTimer< TTimerType >::Reset(), WidgetDimensions::scaled, Window::SetDirty(), SetDParam(), GRFConfig::SetParameterDefaults(), SETTING_BUTTON_HEIGHT, SETTING_BUTTON_WIDTH, GRFConfig::SetValue(), SetWindowDirty(), ShowDropDownListAt(), ShowQueryString(), Rect::Shrink(), TD_RTL, GRFParameterInfo::type, unclick_timeout, WC_DROPDOWN_MENU, WC_GAME_OPTIONS, WC_QUERY_STRING, WID_NP_ACCEPT, WID_NP_BACKGROUND, WID_NP_NUMPAR_DEC, WID_NP_NUMPAR_INC, WID_NP_RESET, WID_NP_SETTING_DROPDOWN, Rect::Width(), and WN_GAME_OPTIONS_NEWGRF_STATE.

## ◆ OnDropdownClose()

void NewGRFParametersWindow::OnDropdownClose | ( | Point | pt,
|  | WidgetID | widget,
|  | int | index,
|  | bool | instant_close
| ) |  |
| inlineoverridevirtual

A dropdown window associated to this window has been closed.

Parameters

  pt | the point inside the window the mouse resides on after closure.
  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.
  instant_close | whether the dropdown was configured to close on mouse up.

Reimplemented from Window.

Definition at line 464 of file newgrf_gui.cpp.

References Window::GetWidget(), Window::SetDirty(), and WID_NP_SETTING_DROPDOWN.

## ◆ OnDropdownSelect()

void NewGRFParametersWindow::OnDropdownSelect | ( | WidgetID | widget,
|  | int | index
| ) |  |
| inlineoverridevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 455 of file newgrf_gui.cpp.

References GetParameterInfo(), Window::GetWidget(), Window::SetDirty(), GRFConfig::SetValue(), and WID_NP_SETTING_DROPDOWN.

## ◆ OnInvalidateData()

void NewGRFParametersWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 486 of file newgrf_gui.cpp.

References Window::CloseChildWindows(), Scrollbar::GetCount(), Window::GetWidget(), GRFConfig::num_valid_params, GRFConfig::param, Scrollbar::SetCount(), Window::SetWidgetDisabledState(), WC_QUERY_STRING, WID_NP_NUMPAR_DEC, and WID_NP_NUMPAR_INC.

## ◆ OnPaint()

void NewGRFParametersWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 325 of file newgrf_gui.cpp.

References Window::DrawWidgets().

## ◆ OnQueryTextFinished()

void NewGRFParametersWindow::OnQueryTextFinished | ( | std::optional< std::string > | str | ) |
| inlineoverridevirtual

The query window opened from this window has closed.

Parameters

  str | the new value of the string, `std::nullopt` if the window was cancelled or an empty string when the default button was pressed, i.e. `str->empty()`.

Reimplemented from Window.

Definition at line 446 of file newgrf_gui.cpp.

References GetParameterInfo(), Window::GetWidget(), Window::SetDirty(), and GRFConfig::SetValue().

## ◆ OnResize()

void NewGRFParametersWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 476 of file newgrf_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_NP_BACKGROUND.

## ◆ SetStringParameters()

void NewGRFParametersWindow::SetStringParameters | ( | WidgetID | widget | ) | const
| inlineoverridevirtual

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.

Reimplemented from Window.

Definition at line 256 of file newgrf_gui.cpp.

References Scrollbar::GetCount(), SetDParam(), and WID_NP_NUMPAR.

## ◆ UpdateWidgetSize()

void NewGRFParametersWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 213 of file newgrf_gui.cpp.

References WidgetDimensions::frametext, FS_NORMAL, GetCharacterHeight(), GetGRFStringFromGRFText(), GetStringBoundingBox(), GetStringMultiLineBoundingBox(), Window::GetWidget(), RectPadding::Horizontal(), line_height, maxdim(), GRFConfig::param_info, Window::resize, WidgetDimensions::scaled, SetDParamMaxValue(), SETTING_BUTTON_HEIGHT, SETTING_BUTTON_WIDTH, RectPadding::Vertical(), WID_NP_BACKGROUND, WID_NP_DESCRIPTION, WID_NP_NUMPAR, WID_NP_NUMPAR_DEC, and WID_NP_NUMPAR_INC.

## Field Documentation

## ◆ action14present

bool NewGRFParametersWindow::action14present

True if action14 information is present.

Definition at line 156 of file newgrf_gui.cpp.

## ◆ clicked_button

int32_t NewGRFParametersWindow::clicked_button

The row in which a button was clicked or INT_MAX when none is selected.

Definition at line 149 of file newgrf_gui.cpp.

## ◆ clicked_dropdown

bool NewGRFParametersWindow::clicked_dropdown

Whether the dropdown is open.

Definition at line 151 of file newgrf_gui.cpp.

## ◆ clicked_increase

bool NewGRFParametersWindow::clicked_increase

True if the increase button was clicked, false for the decrease button.

Definition at line 150 of file newgrf_gui.cpp.

## ◆ clicked_row

int32_t NewGRFParametersWindow::clicked_row

The selected parameter, or INT_MAX when none is selected.

Definition at line 153 of file newgrf_gui.cpp.

Referenced by DrawWidget().

## ◆ closing_dropdown

bool NewGRFParametersWindow::closing_dropdown

True, if the dropdown list is currently closing.

Definition at line 152 of file newgrf_gui.cpp.

## ◆ dummy_parameter_info

GRFParameterInfo NewGRFParametersWindow::dummy_parameter_info
| static

Dummy info in case a newgrf didn't provide info about some parameter.

Definition at line 147 of file newgrf_gui.cpp.

Referenced by GetDummyParameterInfo().

## ◆ editable

bool NewGRFParametersWindow::editable

Allow editing parameters.

Definition at line 157 of file newgrf_gui.cpp.

## ◆ grf_config

GRFConfig* NewGRFParametersWindow::grf_config

Set the parameters of this GRFConfig.

Definition at line 148 of file newgrf_gui.cpp.

Referenced by OnClick().

## ◆ line_height

int NewGRFParametersWindow::line_height

Height of a row in the matrix widget.

Definition at line 154 of file newgrf_gui.cpp.

Referenced by DrawWidget(), and UpdateWidgetSize().

## ◆ unclick_timeout

TimeoutTimer<TimerWindow> NewGRFParametersWindow::unclick_timeout

Initial value:
= {std::chrono::milliseconds(150), [this]() {
this->clicked_button = INT32_MAX;
this->SetDirty();
}}
Window::SetDirty
void SetDirty() const
Mark entire window as dirty (in need of re-paint)
Definition window.cpp:940
NewGRFParametersWindow::clicked_button
int32_t clicked_button
The row in which a button was clicked or INT_MAX when none is selected.
Definition newgrf_gui.cpp:149
Window::GetWidget
const NWID * GetWidget(WidgetID widnum) const
Get the nested widget with number widnum from the nested widget tree.
Definition window_gui.h:977

When reset, unclick the button after a small timeout.

Definition at line 502 of file newgrf_gui.cpp.

Referenced by OnClick().

## ◆ vscroll

Scrollbar* NewGRFParametersWindow::vscroll

Definition at line 155 of file newgrf_gui.cpp.

The documentation for this struct was generated from the following file:

- src/newgrf_gui.cpp